
import 'package:origami_endpoint/models/authzEndpoint.dart';
import 'package:origami_endpoint/models/connectionProtocol.dart';

class EndpointConnection
{
  String name;
  String bindAddress;
  String type;
  String sessionManager;
  AuthzEndpoint authz;
  ConnectionProtocol protocol;
  EndpointConnection({this.authz,this.name,this.sessionManager,this.protocol,this.type,this.bindAddress});
  EndpointConnection.fromJson(dynamic data)
  {
    name=data['name'];
    bindAddress=data['bindAddress'];
    type=data['type'];
    sessionManager=data['sessionManager'];
    if(data['protocol']!=null)
    {
      protocol=ConnectionProtocol.fromJson(data['protocol']);
    }
    if(data['authz']!=null)
    {
      authz=AuthzEndpoint.fromJson(data['authz']);
    }
  }
  static List<EndpointConnection> fromList(dynamic data)
  {
    var l=<EndpointConnection>[];
    for(var a in data)
    {
      l.add(EndpointConnection.fromJson(a));
    }
    return l;
  }
}